#
# ERM Environmental Modelling Assignement 2
# FM 02.12.2015
# anaylsis of 2001 water temperature
#-----------------------------------------------
# set the system environment to English -> personal notebook has German UI 
Sys.setlocale("LC_TIME", "English") # Windows
Sys.setenv(LANG="EN")               # English
library(chron)
library(hydroTSM)
#
# 2000 and 2001
#
at_2000=at_pre_processing(2000)
at_2001=at_pre_processing(2001)
wt_2000=wt_pre_processing(2000)
wt_2001=wt_pre_processing(2001)
gr_2000=gr_pre_processing(2000)
gr_2001=gr_pre_processing(2001)
o2_2000=o2_pre_processing(2000)
o2_2001=o2_pre_processing(2001)
ph_2000=xx_pre_processing(ph,2000)
ph_2001=xx_pre_processing(ph,2001)
ch_2000=xx_pre_processing(ch,2000)
ch_2001=xx_pre_processing(ch,2001)
tu_2000=xx_pre_processing(tu,2000)
tu_2001=xx_pre_processing(tu,2001)
co_2000=xx_pre_processing(co,2000)
co_2001=xx_pre_processing(co,2001)
uv_2000=xx_pre_processing(uv,2000)
uv_2001=xx_pre_processing(uv,2001)
#plot(gr_2000)
#plot(gr_2001)

# two years 2000 and 2001
at2 = rbind(at_2000,at_2001)
wt2 = rbind(wt_2000,wt_2001)
gr2 = rbind(gr_2000,gr_2001)
o22 = rbind(o2_2000,o2_2001)
ph2 = rbind(ph_2000,ph_2001)
ch2 = rbind(ch_2000,ch_2001)
tu2 = rbind(tu_2000,tu_2001)
co2 = rbind(co_2000,co_2001)
uv2 = rbind(uv_2000,uv_2001)

#plot(wt2)

# daily values: mean value of 24 hours
at2d = aggregate(at2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
wt2d = aggregate(wt2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
gr2d = aggregate(gr2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
o22d = aggregate(o22,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
ph2d = aggregate(ph2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
ch2d = aggregate(ch2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
tu2d = aggregate(tu2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
co2d = aggregate(co2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)
uv2d = aggregate(uv2,as.Date(time(wt2)),FUN=mean,na.rm=TRUE)

# seasons 2001
# hydroTSM: spring MAM = March, April, May 
at_spring = extract(at_2001,trgt="MAM")
wt_spring = extract(wt_2001,trgt="MAM")
gr_spring = extract(gr_2001,trgt="MAM")
o2_spring = extract(o2_2001,trgt="MAM")
ph_spring = extract(ph_2001,trgt="MAM")
ch_spring = extract(ch_2001,trgt="MAM")
tu_spring = extract(tu_2001,trgt="MAM")
co_spring = extract(co_2001,trgt="MAM")
uv_spring = extract(uv_2001,trgt="MAM")
# hydroTSM: summer JJA = June, July, August
at_summer = extract(at_2001,trgt="JJA")
wt_summer = extract(wt_2001,trgt="JJA")
gr_summer = extract(gr_2001,trgt="JJA")
o2_summer = extract(o2_2001,trgt="JJA")
ph_summer = extract(ph_2001,trgt="JJA")
ch_summer = extract(ch_2001,trgt="JJA")
tu_summer = extract(tu_2001,trgt="JJA")
co_summer = extract(co_2001,trgt="JJA")
uv_summer = extract(uv_2001,trgt="JJA")
# hydroTSM: summer JJA = June, July, August
at_autumn = extract(at_2001,trgt="SON")
wt_autumn = extract(wt_2001,trgt="SON")
gr_autumn = extract(gr_2001,trgt="SON")
o2_autumn = extract(o2_2001,trgt="SON")
ph_autumn = extract(ph_2001,trgt="SON")
ch_autumn = extract(ch_2001,trgt="SON")
tu_autumn = extract(tu_2001,trgt="SON")
co_autumn = extract(co_2001,trgt="SON")
uv_autumn = extract(uv_2001,trgt="SON")

wtd_spring = extract(wt2d,trgt="MAM")
o2d_spring = extract(o22d,trgt="MAM")
phd_spring = extract(ph2d,trgt="MAM")
chd_spring = extract(ch2d,trgt="MAM")
wtd_summer = extract(wt2d,trgt="JJA")
o2d_summer = extract(o22d,trgt="JJA")
phd_summer = extract(ph2d,trgt="JJA")
chd_summer = extract(ch2d,trgt="JJA")
wtd_autumn = extract(wt2d,trgt="SON")
o2d_autumn = extract(o22d,trgt="SON")
phd_autumn = extract(ph2d,trgt="SON")
chd_autumn = extract(ch2d,trgt="SON")
wtd_winter = extract(wt2d,trgt="DJF")
o2d_winter = extract(o22d,trgt="DJF")
phd_winter = extract(ph2d,trgt="DJF")
chd_winter = extract(ch2d,trgt="DJF")




wt_autumn = extract(wt_2001,trgt="SON")
wt_winter = extract(wt_2001,trgt="DJF")
#plot(wt_winter)

# winter -> extract with window function
winter_2000_2001 <-function(ts)
{
  return(window(ts,start=as.POSIXct(sprintf("%4d-12-01 00:00:00",2000),"UTC"),
                   end  =as.POSIXct(sprintf("%4d-02-28 23:59:59",2001),"UTC")))
}
at_winter = winter_2000_2001(at2)
wt_winter = winter_2000_2001(wt2)
gr_winter = winter_2000_2001(gr2)
o2_winter = winter_2000_2001(o22)
ph_winter = winter_2000_2001(ph2)
tu_winter = winter_2000_2001(tu2)
ch_winter = winter_2000_2001(ch2)
co_winter = winter_2000_2001(co2)
uv_winter = winter_2000_2001(uv2)

# correlation matrix
if(FALSE)
{
# correlation table
  correlation_table <- function(ts_array,ts_name)
  {
    number = length(ts_array)
    row="    "
    for(i in 1:number) row = paste(row,sprintf("%6s",ts_name[i]))
    print(row)
    for(i in 1:number)
    {
      row=""
      row = paste(row,sprintf("%6s",ts_name[i]))
      for(j in 1:number)
      {
        row = paste(row,sprintf("%6.3f",cor(ts_array[[i]],ts_array[[j]],use="na.or.complete"),method="pearson"))
      }
      print(row)
    }
  }
ts_n = list("at","wt","gr","o2","ph","ch","tu","co","uv")
ts   = list(at2,wt2,gr2,o22,ph2,ch2,tu2,co2,uv2)
correlation_table(ts,ts_n)
ts   = list(at2d,wt2d,gr2d,o22d,ph2d,ch2d,tu2d,co2d,uv2d)
correlation_table(ts,ts_n)
ts   = list(at_2000,wt_2000,gr_2000,o2_2000,ph_2000,ch_2000,tu_2000,co_2000,uv_2000)
correlation_table(ts,ts_n)
ts   = list(at_summer,wt_summer,gr_summer,o2_summer,ph_summer,ch_summer,tu_summer,co_summer,uv_summer)
correlation_table(ts,ts_n)
ts   = list(at_winter,wt_winter,gr_winter,o2_winter,ph_winter,ch_winter,tu_winter,co_winter,uv_winter)
correlation_table(ts,ts_n)
}
#
# fucntion scattter plot
#
scatter_plot <- function(ts1,ts2)
{
 scatter.smooth(ts1,ts2)
 lines(loess.smooth(ts1,ts2,span=2/3),col="red") 
 lines(loess.smooth(ts1,ts2,span=1/3),col="blue") 
 lines(loess.smooth(ts1,ts2,span=1/10),col="green") 
}

#
# water temperature vs. air temperature
#
if(FALSE)
{
 cor(wt_2000,at_2000)
 cor(wt_2001,at_2001)
 cor(wt2,at2)
 cor(wt2d,at2d)
 cor(wt_summer,at_summer)

 scatter.smooth(wt2d,at2d)
 lines(loess.smooth(wt2d,at2d,span=2/3),col="red")
 scatter.smooth(wt2,at2)
 lines(loess.smooth(wt2,at2,span=2/3),col="red") 

 scatter.smooth(wt2,at2)
 lines(loess.smooth(wt2,at2,span=2/3),col="red")
 scatter.smooth(wt_2000,at_2000,col="grey")
 lines(loess.smooth(wt_2000,at_2000,span=1/3),col="blue")
 lines(loess.smooth(wt_2000,at_2000,span=1),col="green")
 lines(loess.smooth(wt_2000,at_2000,span=1/3,degree=2),col="orange")
 lines(loess.smooth(wt_2000,at_2000,span=1/30,degree=2),col="red")
 scatter.smooth(wt_2001,at_2001)
 lines(loess.smooth(wt_2001,at_2001,span=2/3),col="red")

 lm(wt_2000 ~ at_2000)
 lm(wt_2001 ~ at_2001)
 lm(wt2 ~ at2)
 lm(wt2d ~ at2d)
}
# daily time series 24 hours 
if(FALSE)
{
as.hour <- function(t) as.numeric(format(t,"%H"))
wt2h = aggregate(wt2,as.hour,FUN=mean)
at2h = aggregate(at2,as.hour,FUN=mean)
wt_2000h = aggregate(wt_2000,as.hour,FUN=mean)
at_2000h = aggregate(at_2000,as.hour,FUN=mean)
gr_2000h = aggregate(gr_2000,as.hour,FUN=mean,na.rm = TRUE)
o2_2000h = aggregate(o2_2000,as.hour,FUN=mean,na.rm = TRUE)

wt_2001h = aggregate(wt_2001,as.hour,FUN=mean)
at_2001h = aggregate(at_2001,as.hour,FUN=mean)

plot(at2h,main="Day Temperature 24h",col="red",ylim=c(8,15))
lines(wt2h,col="blue")
lines(at_2000h,col="red",lty="dashed")
lines(wt_2000h,col="blue",lty="dashed")
lines(at_2001h,col="red",lty="dotted")
lines(wt_2001h,col="blue",lty="dotted")
cor(wt2h,at2h)
cor(wt_2000h,at_2000h)
cor(wt_2001h,at_2001h)
cor(gr_2000h,at_2000h)
scatter_plot(wt_2000h,at_2000h)
scatter_plot(gr_2000h,at_2000h)
scatter_plot(o2_2000h,at_2000h)
plot(gr_2000h)
lines(at_2000h*50-500,col="red",lty="dashed")

a.fit = lm(at_2000 ~ time(at_2000),gr_2000,degree=1)
plot(a.fit)
lines(gr_2000h)
}
#
# water temperature vs. oxygen
#
if(FALSE)
{
 plot(o22d,col= "red")
 lines(wt2d*0.2+8,col="blue",lty="dashed")

 cor(wt_2000,o2_2000)
 cor(wt_2001,o2_2001)
 cor(wt2,o22)
 cor(wt2d,o22d)
 cor(wt_spring,o2_spring)
 cor(wt_summer,o2_summer)
 cor(wt_autumn,o2_autumn)
 cor(wt_winter,o2_winter)
 
 scatter.smooth(wt2d,o22d)
 lines(loess.smooth(wt2d,o22d,span=2/3),col="red") 
 lines(loess.smooth(wt2d,o22d,span=1/3),col="blue") 
 scatter.smooth(wt2,o22)
 lines(loess.smooth(wt2,o22,span=2/3),col="red") 
 lines(loess.smooth(wt2,o22,span=1/3),col="blue") 

# summer
 scatter_plot(wt_summer,o2_summer)
 scatter_plot(wtd_summer,o2d_summer)
 
 scatter_plot(phd_summer,o2d_summer)
 scatter_plot(phd_winter,o2d_winter)
 scatter_plot(phd_autumn,o2d_autumn)
 scatter_plot(phd_spring,o2d_spring)
 scatter_plot(phd_summer,o2d_summer)
 scatter_plot(phd_summer,o2d_summer)
 
 scatter_plot(ph_summer,o2_summer)
 scatter_plot(ch_summer,o2_summer)
 scatter_plot(ch_summer,tu_summer)
 scatter_plot(ch_summer,gr_summer)
 
# spring
 scatter_plot(wt_spring,o2_spring)
 scatter_plot(wtd_spring,o2d_spring)
 
# autumn
 scatter_plot(wt_autumn,o2_autumn)
 scatter_plot(wtd_autumn,o2d_autumn)
 
# winter
 scatter_plot(wt_winter,o2_winter)
 scatter_plot(wtd_winter,o2d_winter)
 
 wt_july = window(wt_2001,start=as.POSIXct(sprintf("%4d-07-01 00:00:00",2001),"UTC"),
                            end  =as.POSIXct(sprintf("%4d-07-31 23:59:59",2001),"UTC"))
 o2_july = window(o2_2001,start=as.POSIXct(sprintf("%4d-07-01 00:00:00",2001),"UTC"),
                            end  =as.POSIXct(sprintf("%4d-07-31 23:59:59",2001),"UTC"))
 scatter_plot(wt_july,o2_july)

# fresh water oxygen saturation 
if(FALSE)
 {
  T = c(0,5,10,15,20,25,30,35)
  S = c(14.6,12.8,11.3,10.1,9.1,8.3,7.6,7.0) 
  plot(T,S,main="Oxygen Saturation",xlab="T [C]",ylab="O2 [mg/l]",type="p",col="blue")
  lines(T,S,col="orange",lty="dashed")
 }

scatter_plot_2d <- function(water_temperature,oxygen_saturation)
{
  scatter.smooth(water_temperature,oxygen_saturation,xlim=range(2,28),ylim=range(5,20))
  lines(loess.smooth(water_temperature,oxygen_saturation,span=2/3),col="red") 
  lines(T,S,col="orange",lty="dashed")
}
scatter_plot_cho22d <- function(chlorophyll_a_total,oxygen_saturation)
{
  scatter.smooth(chlorophyll_a_total,oxygen_saturation,xlim=range(0,140),ylim=range(6,18))
  lines(loess.smooth(chlorophyll_a_total,oxygen_saturation,span=2/3),col="red") 
}

scatter_plot_2d(wt2d,o22d)
scatter_plot_2d(wtd_spring,o2d_spring)
scatter_plot_2d(wtd_summer,o2d_summer)
scatter_plot_2d(wtd_autumn,o2d_autumn)
scatter_plot_2d(wtd_winter,o2d_winter)

scatter_plot_cho22d(ch2d,o22d)
scatter_plot_cho22d(chd_spring,o2d_spring)
scatter_plot_cho22d(chd_summer,o2d_summer)
scatter_plot_cho22d(chd_autumn,o2d_autumn)
scatter_plot_cho22d(chd_winter,o2d_winter)
}

if(FALSE)
{
scatter.smooth(co2d,ph2d)
scatter.smooth(ch2d,ph2d)
scatter.smooth(wt2d,ph2d)
scatter.smooth(uv2d,ph2d)
scatter.smooth(uv2d,wt2d)
scatter.smooth(ch2d,uv2d)
scatter.smooth(ch2d,co2d)

scatter.smooth(ph2d,o22d)
scatter.smooth(ch2d,o22d)
scatter.smooth(ch_spring,o2_spring)
scatter.smooth(ch_summer,o2_summer)
scatter.smooth(ch_autumn,o2_autumn)
scatter.smooth(ch_winter,o2_winter)
plot(ch_winter)
lines(o2_winter,col="blue")
}