#
# control script
# running R scripts for Havel Water Data Analysis 
# not optimized for performance !!
#-----------------------------------------
# set the system environment to English -> personal notebook has German UI 
Sys.setlocale("LC_TIME", "English") # Windows
Sys.setenv(LANG="EN") 

# general part: preparating work environment: reading data and functions 
# reading time series
source("WQTSFile_InputOutput.R")
# operational functions
source("WQTSFile_Management.R")
# analysis functions
source("WQTSFile_Analysis.R")
# plot functions
source("WQTSFile_PlotFunctions.R")
# metadata
source("WQTSFile_Correlation.R")
# metadata
source("WQTSFile_MetaData.R")


#-------------------------------------------------------------
# specific part to perform time series management and analysis
# general time series features 
if(FALSE)
{
 print(paste("Air Temperature:  min",min(ts_air_temperature[,2])))
 print(paste("                  max",max(ts_air_temperature[,2])))
 print(paste("                  mean",mean(ts_air_temperature[,2])))
 print(paste("                  sd",sd(ts_air_temperature[,2])))
 print(paste("                  var",var(ts_air_temperature[,2])))

#
# monthly values
#
 for(i in 1:12) 
  {
   month_time_series = extract_month_subset(ts_air_temperature,i)
   print(paste("                  sd",i,sd(month_time_series[,2])))
  }
}

#
# histogram
#
if(FALSE)  
{
#hist(ts_air_temperature[,2])
hist(extract_month_subset(ts_air_temperature,9)[,2])
}


#
# aggregation
#
if(FALSE)
{
print("aggregation")
as.yearhour <- function(t) {return(as.numeric(format(t,"%j"))*24+ as.numeric(format(t,"%H")))}
as.hour <- function(t) as.numeric(format(t,"%H"))
as.week <- function(t) as.numeric(format(t,"%u"))
as.yearweek <- function(t) as.numeric(format(t,"%V"))

th = aggregate(t,as.hour,FUN=mean)
tyh = aggregate(t,as.yearhour,FUN=mean)
tyd = aggregate(t,as.Date(time(t)),FUN=mean)
tw = aggregate(t,as.week,FUN=mean)
tyw = aggregate(t,as.yearweek,FUN=mean)
tym = aggregate(t,as.yearmon(time(t)),FUN=mean)

plot(tym, col="darkgreen")
}

#
# zoo extraction 
#
if(FALSE)
{
print("extraction")
 t_july = window(t,start=as.POSIXct("2010-07-11 00:00:00","UTC"),end=as.POSIXct("2010-09-11 23:59:59","UTC"))
 plot(t_july)
}
}

#
# linear regression
#
if(FALSE)
{
print("linear regression")
#month_time_series = ts_air_temperature
month_time_series = extract_month_subset(ts_air_temperature,11)

linear_regression = lm(Wert ~ Datum,data=month_time_series)
plot(month_time_series)
abline(linear_regression, lty="dashed")
}

#
# correlation
#
if(FALSE)
{
print("correlation")
# acf(ts_precipitation[,2])
 #acf(ts_air_temperature[,2])

#ccf(ts_air_temperature[,2],ts_soil_temperature[,2])
 ccf(ts_precipitation[,2],ts_soil_temperature[,2])
}

#
# seasonal decomposition
# 
#if(FALSE)
{
  print("seasonal decomposition")
library(hydroTSM)
tl.raw <- read.csv(file = "DWDFile_Analysis/tl.txt",sep="\t", header=F,dec=","
                   ,col.names=c("date","value","no data"), stringsAsFactors=F) 
tl.Vdata <- read.zoo(tl.raw[,1:2],format="%d.%m.%Y %H:%M",tz="UTC")
tl.monthly <- subdaily2monthly(tl.timeseries, FUN=mean)
plot(tl.monthly,main="Monthly data Air Temperature", xlab="Date", ylab="C")
tl.ts<-ts(tl.monthly[,2],start=c(1996,1),frequency=12)
plot(decompose(tl.ts,type=c("additive"),filter=NULL))
plot(stl(tl.ts,s.window="periodic"),main="Decomposition by LOESS")
}

